-- vyměněny osy X a Y, mírně upravena i osa Z 
--[[
  ¦***************************************************¦
  ¦        Horizont, poloměr 60 řádků                 ¦
  ¦                                                   ¦
  ¦         *** ellet *** 2021 ***                    ¦
  ¦                                                   ¦
  ¦ Odstraněním některého nebo všech obrázků          ¦
  ¦ se změní vzhled.                                  ¦
  ¦                                                   ¦
  ¦ Parametry kalX, kalY, kalZ (kalibrace X,Y,Z)      ¦
  ¦ slouží k nulování při nulové letové poloze.       ¦
  ¦ Zobrazení směru lze zakázat nastavením hodnoty    ¦ 
  ¦ 181 (nebo -181) v parametru kalZ.                 ¦
  ¦                                                   ¦
  ¦ Parametry invK, invV lze obrátit sklon            ¦
  ¦ aby vyhovoval poloze Rx a nastavení serv.         ¦
  ¦     (-: užívejte drobné radosti :-)               ¦
  ¦***************************************************¦
--]]
 
local sroub = Bitmap.open("/WIDGETS/Hzont60/img/sroub.png")
local picture = Bitmap.open("/WIDGETS/Hzont60/img/mask62.png")
local pict2 = Bitmap.open("/WIDGETS/Hzont60/img/AccZ48.png")

local XL = {}
local XP = {}
local Yb  = {}

local XLk = {}
local XPk = {}

local Sx = 300  
local Sy = 122 
local r = 60
local fl = 0
--mkX = 0
--mkY = 0
--mkZ = 0
--mX = 0
--mY = 0

--local tst=0

local options = {
  {"kalX", VALUE, 0, -30, 30},  -- nastavení nuly 
  {"kalY", VALUE, 0, -30, 30},
  {"kalZ", VALUE, 0, -181, 181},
  {"invK", BOOL, 0},            -- opačný sklon
  {"invV", BOOL, 0}
 }

-----------------------------------------------------
local function create(zone, options)
 local wgt = {zone = zone, options = options}

if wgt.zone.h > 150 then

  if wgt.zone.x > 20 then
    Sx = wgt.zone.x + 64 -- + 60
    Sy = wgt.zone.y + 64     -- + 62
    for i=0, 2*r do 
      XL[i]=Sx-r+1 
      XP[i]=Sx+r+1
      Yb[i]=Sy+i-r
    end
  elseif wgt.zone.x < 21 then
    Sx = wgt.zone.x + 70
    Sy = wgt.zone.y + 62
    for i=0, 2*r do 
      XL[i]=Sx-r+1 
      XP[i]=Sx+r+1
      Yb[i]=Sy+i-r
    end
  end  -->20

for i=-r, r do  
  local y1 = Sy+i 
  local x1 = math.sqrt((r*r) - (i*i))
  XLk[i+r]=Sx-x1
  XPk[i+r]=Sx+x1
end

end

return wgt
end
-------------------------------------------------------
local function update(wgt, options)
  if (wgt == nil) then
    return
  end
-- mkX = wgt.options.kalX 
-- mkY = wgt.options.kalY 
-- mkZ = wgt.options.kalZ 
-- mX = wgt.options.invK 
-- mY = wgt.options.invV 

  wgt.options = options
end
---------------------------------------------
local function background(wgt)
  return
end
--------------------------------------------------------
function round(num, decimals)
  local mult = 10^(decimals or 0)
  return math.floor(num * mult + 0.5) / mult
end
---------------------------------------------------------
--------------------------------------------------------
---------------------------------------------------------
function refresh(wgt)

if (wgt == nil) then
  return
end
if (wgt.options == nil) then
  return
end
if wgt.zone.h < 145 then
 lcd.drawText(wgt.zone.x+2,wgt.zone.y+5, "Vyjmout!!!")
 return
end

lcd.drawText(wgt.zone.x+5,wgt.zone.y+20, "Vyjmout!!!")
if math.abs(wgt.options.kalZ)==181 then fl=1 else fl=0 end

local vys = 0
local kri = 0

vys = getValue("AccX")
vys = (vys*90) + wgt.options.kalX 
if wgt.options.invV==1 then vys = 0 - vys end
     
kri = getValue("AccY")
kri = (kri*90) + wgt.options.kalY
if wgt.options.invK==1 then kri = 0 - kri end

kri=math.floor(kri)
vys=math.floor(vys)
if kri>30 then kri=30 end
if kri<-30 then kri=-30 end
if vys>30 then vys=30 end
if vys<-30 then vys=-30 end

-- modrý ctverec ---------------------------------
lcd.setColor(LINE_COLOR, BLUE)
for i = 0, 2*r do  
  lcd.drawLine(XL[i],Yb[i],
               XP[i],Yb[i], SOLID,LINE_COLOR)
end
--------------------------------------------
lcd.setColor(LINE_COLOR, YELLOW)
----------------------------------------------
if (kri==0) then    
  for i = r+vys, 2*r do  
    lcd.drawLine(XL[i],Yb[i],
                 XP[i],Yb[i], SOLID,LINE_COLOR)
  end
end -- if nakl==0
----------------------------------------------
if kri>0 then
  local k2 = 2*kri
  local d = 0
  local p = -1
  local max = r+kri+vys
  if max>(2*r) then max=2*r end
-- 
  for i=r-kri+vys, max do  
    p=p+1
    d=p*(XP[i]-XL[i])/k2
    lcd.drawLine(XL[i],Yb[i],
                 XL[i]+d,Yb[i], SOLID,LINE_COLOR)
  end
-- 
  for i=max, 2*r do
   lcd.drawLine(XL[i],Yb[i],
               XP[i],Yb[i], SOLID,LINE_COLOR)
  end
end -- if kri>0
-------------------------------------------------
if kri<0 then
  local kri1 = -kri
  local d = 0
  local k2 = 2*kri1
  local p = k2+1
  local max = r+kri1+vys
  if max>(2*r) then max=2*r end
-- 
  for i = r-kri1+vys, max do  
    p=p-1
    d=p*(XP[i]-XL[i])/k2
    lcd.drawLine(XL[i]+d,Yb[i],
                 XP[i],Yb[i], SOLID,LINE_COLOR)
  end
-- 
  for i=max, 2*r do
   lcd.drawLine(XL[i],Yb[i],
               XP[i],Yb[i], SOLID,LINE_COLOR)
  end
end -- if kri<0
--------------------------------------------------------

local rs = getValue("AccZ")
rs = rs * 100
rs = rs + wgt.options.kalZ

if rs<0 then rs=360-math.abs(rs) end
if rs>89 then rs = rs + 0.01 end

--lcd.drawNumber(80,95,rs)
 
local xx = math.sin(rs/57.3) * 19
local yy = math.cos(rs/57.3) * 19
yy = -yy

----------------------------------------------------

lcd.setColor(LINE_COLOR, 623)  -- 61200) -- 65280) --255)
for i = 0, 2*r do 
  lcd.drawLine(XL[i]-1,Yb[i],
               XLk[i],Yb[i], SOLID, LINE_COLOR)
  lcd.drawLine(XPk[i],Yb[i],
               XP[i],Yb[i],SOLID,LINE_COLOR)
end
-------------------------------------------------

lcd.drawBitmap(picture,Sx-63,Sy-63)    
lcd.setColor(LINE_COLOR, RED)
lcd.drawLine(XL[r]-10, Sy, 
             XP[r]+10, Sy, SOLID,LINE_COLOR)

----------------------------------------
if fl == 0  then 
  lcd.setColor(LINE_COLOR, RED)
  lcd.drawBitmap(pict2, Sx-74, Sy-74) 
  lcd.drawLine(Sx-50+xx, Sy-50+yy, Sx-50, Sy-50, SOLID, LINE_COLOR)
end
--------------------------------------------------

 lcd.setColor(CUSTOM_COLOR, BLACK)

 local vyska = getValue("Alt")
  if vyska<100 then 
    lcd.drawText(Sx-23, Sy-40, "Alt: "..round(vyska), CUSTOM_COLOR) -- + SHADOWED) 
  else
    lcd.drawText(Sx-30, Sy-40, "Alt: "..round(vyska), CUSTOM_COLOR) -- + SHADOWED)
  end
 lcd.setColor(CUSTOM_COLOR, RED)
  if vyska<100 then 
    lcd.drawText(Sx-24, Sy-41, "Alt: "..round(vyska), CUSTOM_COLOR) -- + SHADOWED) 
  else
    lcd.drawText(Sx-30, Sy-40, "Alt: "..round(vyska), CUSTOM_COLOR) -- + SHADOWED)
  end


 lcd.setColor(CUSTOM_COLOR, YELLOW) --BLACK) -- WHITE) -- 65535) -- RED) --YELLOW)
 local rssi = getValue("RSSI")
 local vfr = getValue("VFR")
 local a2 = getValue("A2")
 local nap = getValue("RxBt")
 local spd = getValue("VSpd")

 lcd.drawText(Sx+62, Sy+40, "A2: "..round(a2,1).."V", CUSTOM_COLOR + SMLSIZE+ SHADOWED) 
 lcd.drawText(Sx+55, Sy+65, "RxBt: "..round(nap,1).."V", CUSTOM_COLOR + SMLSIZE+ SHADOWED)
 lcd.drawText(Sx-47, Sy+65, "VSpd: "..round(spd,1).." m/s", CUSTOM_COLOR + SMLSIZE +SHADOWED)
 if vfr>99 then
   lcd.drawText(Sx+62, Sy-25, "VFR: "..round(vfr), CUSTOM_COLOR+ SMLSIZE + SHADOWED)
 else
   lcd.drawText(Sx+67, Sy-25, "VFR: "..round(vfr), CUSTOM_COLOR + SMLSIZE+ SHADOWED)
 end
 if rssi>99 then
   lcd.drawText(Sx+58, Sy-50, "RSSI: "..round(rssi), CUSTOM_COLOR+ SMLSIZE + SHADOWED)
 else
   lcd.drawText(Sx+62, Sy-50, "RSSI: "..round(rssi), CUSTOM_COLOR+ SMLSIZE + SHADOWED)
 end

 lcd.drawBitmap(sroub,Sx+46,Sy-51) 
 lcd.drawBitmap(sroub,Sx+46,Sy+46)
 lcd.drawBitmap(sroub,Sx-52,Sy+46) 
 if fl==1 then
   lcd.drawBitmap(sroub,Sx-52,Sy-51) 
 end

 lcd.setColor(LINE_COLOR, GREY)
 return
end

return {
  name = "Hzont60",
  options = options,
  create = create,
  update = update,
  background = background,
  refresh = refresh
}